package com.trs.ggzyexchange.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.entity.Bulletin;
import com.trs.ggzyexchange.entity.Changeitembulletin;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.service.BulletinService;
import com.trs.ggzyexchange.service.ChangeitembulletinService;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-09-27
 */
@RestController
@RequestMapping("/bulletin")
public class BulletinController extends BaseController {

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private BulletinService bulletinService;

    //@GetMapping(value = "/queryChangeItemBulletininUpdateEs")
    public Integer queryBulletinUpdateEs() throws JsonProcessingException {
        int count = bulletinService.count();
        Integer pageSize = 1000;
        Integer pageNum = (int)Math.ceil((double)count/pageSize);
        List<TenderDetailsVo> tenderDetailsVosList = new ArrayList<TenderDetailsVo>();
        for(int i = 1; i <= pageNum;i++){
            QueryWrapper<Bulletin> queryWrapper = new QueryWrapper<Bulletin>();
            Page<Bulletin> page = new Page<Bulletin>(i, pageSize);
            IPage<Bulletin> pageList = bulletinService.page(page, queryWrapper);
            List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
            for (Bulletin bulletin : pageList.getRecords()) {
                TenderDetailsVo tenderDetailsVo = new TenderDetailsVo();
                tenderDetailsVo.setSourceDataKey(bulletin.getGuid());
                tenderDetailsVo.setProjectCode(bulletin.getPurchaseprojectcode());
                tenderDetailsVo.setProjectName(bulletin.getPurchaseprojectname());
                tenderDetailsVo.setTenderProjectCode(bulletin.getPurchaseprojectcode());
                tenderDetailsVo.setNoticeName(bulletin.getBulletintitle());
                tenderDetailsVo.setNoticeContent(bulletin.getBulletincontent());
                tenderDetailsVo.setNoticeSendTime(bulletin.getBulletinstarttime());
                tenderDetailsVo.setNoticeTypeCode(ClassIfy.PREQUALIFICATION_ANNOUNCEMENT.getCode());
                tenderDetailsVo.setNoticeTypeName(ClassIfy.PREQUALIFICATION_ANNOUNCEMENT.getName());
                tenderDetailsVo.setTransactionTypeCode(ClassIfy.GOVERNMENT_PROCUREMENT.getCode());
                tenderDetailsVo.setTransactionTypeName(ClassIfy.GOVERNMENT_PROCUREMENT.getName());
                tenderDetailsVo.setRegionCode(bulletin.getCode());
                tenderDetailsVo.setRegionName(bulletin.getCodePram());
                tenderDetailsVo.setDataSourceCode(bulletin.getJyptid());
                tenderDetailsVo.setBidOpenTime(bulletin.getBulletinstarttime());
                tenderDetailsVo.setBidFinishTime(bulletin.getBidclosingtime());
                tenderDetailsVo.setDataSourceCode(bulletin.getJyptid());
                tenderDetailsVos.add(tenderDetailsVo);
                TenderDetailsVoUtils.isNull(tenderDetailsVo);
            }
            tenderDetailsVosList = tenderDetailsVos;
            Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVos);
        }
        return tenderDetailsVosList.size();
    }
}